TableName[1] = "Ref"
TableName[2] = "Ath"
TableName[3] = "Ins"
TableName[4] = "Nam"
TableName[5] = "Src"
TableName[6] = "Abs"
TableName[7] = "Key"

PROC SubstractTable()
  CURSOR NORMAL
  NameDB = GetFile("*.ref", "Name:",
    "Enter base name of ASCII files (without extension) or directory",
    Dir, TRUE)
  CURSOR OFF
  IF NameDB = "" THEN
    RETURN
  ENDIF
  FOR i FROM 1 TO 7
    DeleteFile(i)
  ENDFOR
ENDPROC

PROC DeleteFile(i)
  CREATE "Temp" LIKE TableName[i]
  MESSAGE "Deleting in " + TableName[i]
  MENU {Tools} {ExportImport} {Import} {Ascii} {AppendDelimited}
  SELECT NameDB + "." + TableName[i]
  SELECT "Temp" {NewEntries}
  IF ISTABLE("Keyviol") OR ISTABLE("Problems") THEN
    DEBUG
  ENDIF
  SUBTRACT "Temp" TableName[i]
  DELETE "Temp"
ENDPROC

SubstractTable()
