; Copyright (c) 1988, 1989 Borland International.  All Rights Reserved.
;
; General permission to re-distribute all or part of this script is granted,
; provided that this statement, including the above copyright notice, is not
; removed.  You may add your own copyright notice to secure copyright
; protection for new matter that you add to this script, but Borland
; International will not support, nor assume any legal responsibility for,
; material added or changes made to this script.
;
; Revs.:  MJP 5/31/88, DCY 12/13/88
; ****************************************************************************
; RefreshCanvas refreshes the canvas with the current contents of the
; workspace.
;
; RefreshCanvas is useful in conjunction with Paradox Runtime, which does
; not support the ECHO NORMAL command.  Since ECHO NORMAL is supported in
; interactive Paradox, you won't need to use RefreshCanvas unless you plan
; to distribute your program under Paradox Runtime.
;
; NOTE:  The Toolkit's Runtime version of RefreshCanvas is specifically 
;        designed to be called no more than once per second.  If called more
;        frequently, it will pause until a second has elapsed.  This should
;        not be noticeable as long as your Runtime procedure does not attempt
;        to mimic interactive Paradox.
;
Proc RefreshCanvas()
   Echo Normal     ;Show the current workspace
   Echo Off        ;Freeze the canvas (capture the current workspace image)
   SyncCursor      ;Restore cursor
Endproc
